%Matlab code for figure 4 in section 3.2.1 in "Low-cost, readily available 3D microscopy imaging system with variable focus spinner"
%Raw image could be download form supplementary material
%Code was checked under windows/mac in Matlab R2016a.

clear all; close all; clc;

%this path should be changed according to the image folder
startfn='images/ruler/raw/';

NoImage = 12; %total images
index_line = 200; %marker line

%load images
for i=0:11
    Imagename = strcat(startfn, num2str(i),'.bmp');
    A{i+1}=imread(Imagename);
end

%compute gradient
for i=1:12
    [Gx{i},Gy{i}]=gradient(im2double(rgb2gray(A{i})));
    A_s{i}=smooth(Gy{i}(:,index_line));    
end

%show all raw images
figure('Name','Raw Images')
for i=1:12
    subplot(6,2,i);
    imshow(A{i});hold on;
    line([index_line index_line], [0 1024]);hold on
    title(strcat('Image No ',num2str(i),'/',num2str(NoImage)));
end

%show marker images
for i=1:2:12
    figure('Name','Marker Images')
    imshow(A{i});hold on;
    line([index_line index_line], [0 1024],'LineWidth',5);
    title(strcat('Image No ',num2str(i),'/',num2str(NoImage)));
end

%show Gradient 
figure('Name','Gradient')
for i=1:12
    subplot(12,1,i);
    plot(Gy{i}(:,index_line),'b');
    xlim([0 1020]);
    ylim([-0.2 0.2]);
    hold on
end
